#!/usr/bin/perl

#############################################################################
## Program Name: openjournal.cgi  version 1.01
##
## Open Journal (OJ)
## John M. Grohol
## Released: 10 Oct 1999
## This version: 10 Oct 1999
## http://grohol.com/
##
## Copyright 1999 John M. Grohol.
## Free to distribute or change, but you cannot charge for this work or any
## derivatives thereof. No warranties on this program are made or implied.
##
## Description:
## Allows you to keep a weblog with minimal maintenance.
##
## Quick Installation Instructions:
##  1. Create a directory for your openjournal to live in (e.g., "openjournal")
##  2. Create a subdirectory under the openjournal directory called "story" (configurable below)
##  3. Make sure whatever user the Web server is running as can write to the directory
##     *and* subdirectory (e.g., chmod 777 openjournal)
##  4. Copy the oj.template file into the openjournal directory
##  5. Copy the oj.archive  file into the openjournal/story subdirectory
##  6. Change variables below to configure and customize the script:

$mydir   = "/home/ftp/webpsych/prod";  # The directory where your homepage lives - no trailing slash
$ojdir   = "/openjournal";             # Where your journal will reside on your Website
				       # - no trailing slash
$baseurl = "http://www.grohol.com";    # Your Website's URL - no trailing slash
$cgi_url = $baseurl . "/cgi-bin/openjournal.cgi";     # Change if necessary (cgi-bin dir)
$title   = "my open journal";          # Name of your journal
$mesgdir  = "story";		       # Create a subdirectory under where your open journal lives
				       # The default directory is called "story"
$ext      = "htm";		       # If your system needs "html" extensions, change it here
$mesgfile = "index." . $ext;	       # Default index file
$daytoarchive = "5";   	# 0=Sun, 1=Mon, 2=Tues, etc. if you only want to archive once a month, 
			# set this variable to 30.

### !!!!! IMPORTANT !!!!!!! ############################
### Change these defaults before you run this puppy! ###
### This is your login to add new entries to your    ###
### journal.                                         ###
########################################################

$username = "admin";
$password = "stupidboy";

# Specify colors and background:

$colors   = qq~
bgcolor="#FFFFEE" 
tect="#000000" 
link="#000044" 
vlink="#884400" 
~;

$background = qq~ background="" ~;

# Pick a default font face, size, and table color to use:

$font     = "arial,helvetica";
$size     = "-1";
$tcolor   = " bgcolor=\"#CCCCAA\"";
$tbcolor  = " bgcolor=\"#005544\"";
$tbfontcolor = "#FFFFFF";  
$tbfont   = "verdana,ms sans serif";

# Need to change where the "date" program on your system lives?

$d = "/usr/bin/date";
$ENV{"TZ"} = "EST5EDT"; 
$long_date = `$d +"%B %-d, %Y"`; chop($long_date);
$w = `$d +"%w"`; chop($w);
$today = `$d +"%d"`; chop($today);

# Note: If your date system doesn't support the syntax below (Linux does!),
# then this may not work. Sorry.

$lastmonth = `$d --date '1 month ago' +"%m"`; chop($lastmonth);
$nfn = `$d +"%m%d%y%H%M"`; chop($nfn);
$lastweek = `$d --date '1 week ago' +"%B %-d, %Y"`; chop($lastweek);
$ngn = `$d +"%m%d"`; chop($ngn);
$nyn = `$d --date '1 day ago' +"%m%d"`; chop($nyn);

#_______________________________________________________

$blurbonly = 0;
$basedir = $mydir . $ojdir;
$john    = $baseurl . "/";
$idxurl  = $baseurl . "$ojdir/";

&ParseTags($ENV{'PATH_INFO'});
&ParseTags($ENV{'QUERY_STRING'}); 

if (!($tags{'admin'})) {
  &parse_form;
  &get_variables;
  if ($blurbonly eq 0) { &new_file; }
  &main_page;
  &return_html;
} else {
  &print_auth;
}

exit 0;

#_______________________________________________________

sub get_variables {

   $fusername = $FORM{'username'};
   $fpassword = $FORM{'password'};
   if ($FORM{'auth'} eq "login") { &auth; }

   if ($fusername ne $username) { &error("Not logged in"); }
   if ($FORM{'etitle'}) {
      $etitle = "$FORM{'etitle'}";
      $headtitle = $etitle;
      $etitle =~ s/"/\&quot;/g;
      $etitle =~ s/<//g;
      $etitle =~ s/>//g;
      $etitle =~ s/\&/\&amp;/g;
   }
   else {
      &error("No title");
   }

   if ($FORM{'bodyone'}) {
      $bodyone = "$FORM{'bodyone'}";
      $bodyone =~ s/\cM//g;
      $bodyone =~ s/\n\n/<p>/g;  
      $bodyone =~ s/&lt;/</g;
      $bodyone =~ s/&gt;/>/g;
   }
   else {
      &error("No blurb");
   }

   if ($FORM{'body'}) {
      $body = "$FORM{'body'}";
      $body =~ s/\cM//g;
      $body =~ s/\n\n/<p>/g;   

# v1.01 - added single line below

      $body =~ s/\n/<br>/g;
      $body =~ s/&lt;/</g; 
      $body =~ s/&gt;/>/g; 
   }

   if (length($body) < 5) { $blurbonly = 1; }

}

# Write a new article routine

sub new_file {

   open(NEWFILE,">$basedir/$mesgdir/$nfn\.$ext") || die $!;

   print NEWFILE qq~

<html><head><title>$title: $headtitle</title></head>
<body $colors $background>

<font face="$font" size="+2"><b>$title</b></font><br>
<font face="$font" size="$size">
<a href="$idxurl">home</a> . 
<a href="$idxurl/$mesgdir">archives</a>
</font>
<p>
<ul>

<table border=0 cellpadding=4 cellspacing=0 width="75%"><tr><td bgcolor="#FFFFEE" valign=top>
<font size="+2" face="$font"><b>$etitle</b></font><p>
<font face="$font" size="$size">
$body
</font>

</td></tr></table>
</ul>
<p>
<font size="-2" face="ms sans serif,verdana,helvetica" color="#888899">Open Journal is open source software by
<span style="color:#888899; text-decoration:none"><a style="color:#888899; text-decoration:none" 
href="http://www.grohol.com/">J. Grohol</a></span>.
</font></p>
</body></html> 

~;

close(NEWFILE);

chmod 0755, "$basedir/$mesgdir/$nfn\.$ext";     

}

# Adds article to index page

sub main_page {

# Time to archive?
   &lastarchive;
   $lastarchmon = substr($lastarch,0,2);
   if (($lastarch ne $ngn) && ( ( ($daytoarchive ne 30) && ($w eq ($daytoarchive+1)) ) ||
	( ($daytoarchive eq 30) && ( ($today eq 01) || ($lastarchmon eq $lastmonth)) ))) {
	$result = `mv $basedir/$mesgfile $basedir/$mesgdir/idx$nfn\.$ext`;
	$result = `cp $basedir/oj\.template $basedir/$mesgfile`;

   open(AMAIN,"$basedir/$mesgdir/$mesgfile") || die $!;
   @amain = <AMAIN>;
   close(AMAIN);

   open(AMAIN,">$basedir/$mesgdir/$mesgfile") || die $!;
      foreach $amain_line (@amain) {
         if ($amain_line =~ /<!--begin-->/) {
            print AMAIN "<!--begin-->\n";
            print AMAIN "<font face=\"$font\" size=\"$size\"><a href=\"$ojdir/$mesgdir/idx$nfn\.$ext\">Week of $lastweek</a></font><br>\n";
         }
         else {
            print AMAIN "$amain_line";
         }
      }
   close(AMAIN);
   &archive;
   } 

# Add entry to main index page

&lastupdate;
if ($lastupdate ne $ngn) { $newday = 1; } else { $newday = 0; }

   open(MAIN,"$basedir/$mesgfile") || die $!;
   @main = <MAIN>;
   close(MAIN);


   open(MAIN,">$basedir/$mesgfile") || die $!;
      foreach $main_line (@main) {
#	if ($main_line =~ /<!--topoftoday $ngn-->/) {
#		$iu = substr($main_line,-8,4);
#		if ($ngn ne $iu) { $newday = 1; }
#		else { $newday = 0; }
#	}

        if (($newday eq 0) && ($main_line =~ /<!--topoftoday $ngn-->/)) {
		print MAIN "\n\n<!--topoftoday $ngn-->\n\n";
        if ($blurbonly eq 1) {
                print MAIN "<font face=\"$font\" size=\"$size\"><b>$etitle</b><br>$bodyone</font><p>\n";
        } else {
                print MAIN "<font face=\"$font\" size=\"$size\"><a href=\"$ojdir/$mesgdir/$nfn\.$ext\"><b>$etitle</b></a><br>$bodyone</font><p>\n";
        }
	 } elsif (($newday eq 1) && ($main_line =~ /<!--topper-->/)) { 
		print MAIN "\n\n<!--topper-->\n\n";
                print MAIN "<table width=\"100\%\" border=0 cellpadding=2 cellspacing=0><tr><td $tbcolor valign=top>\n";
                print MAIN "&nbsp;<font color=\"$tbfontcolor\" face=\"$tbfont\">$long_date</font></td></tr></table><br>\n<!--topoftoday $ngn-->\n\n";
	if ($blurbonly eq 1) {
    		print MAIN "<font face=\"$font\" size=\"$size\"><b>$etitle</b><br>$bodyone</font><p>\n";
	} else {
                print MAIN "<font face=\"$font\" size=\"$size\"><a href=\"$ojdir/$mesgdir/$nfn\.$ext\"><b>$etitle</b></a><br>$bodyone</font><p>\n";
	}

         } else {
            print MAIN "$main_line";
         }
      }
   close(MAIN);

&update;

}

sub return_html {
   &header("entry added");
   print "<h3><font face=\"$font\">$title: entry added</font></h3>\n";
   print "<ul>";
	if ($blurbonly eq 0) { print "<li><a href=\"$ojdir/$mesgdir/$nfn\.$ext\"><b>$etitle</b></a>\n";
	}
   print "<li><a href=\"$idxurl\">$title index</a>\n";
   print "</ul><p>\n";
   &footer;
}

sub error {
   $error = $_[0];
   &header(error);
   print "<h3><font face=\"$font\">error: $error</font></h3></body></html>\n";
   exit(0);
}

sub header {
   $subtitle = $_[0];
   print "Content-type: text/html\n\n";
   print "<html><head><title>$title: $subtitle</title></head><body $colors $background>\n";
}

sub footer {
   print "</body></html>";
}

sub ParseTags {
        local($_) = @_;
        local(@terms, $tag, $val);
        s|^/||;
                @terms = split('&');
                foreach $term (@terms) {
                        ($tag,$val) = split('=',$term,2);
if ((length($tag) > 100) || (length($val) > 100)) { &error("Variable length problem in line input"); }
      $val =~ tr/+/ /;
      $val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $val =~ s/<!--(.|\n)*-->//g;
      $val =~ s/<([^>]|\n)*>//g;
                        # may override previous value
                        $tags{$tag} = $val;
                }
}

sub parse_form {
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);
if ((length($name) > 100) || (length($value) > 10000)) { &error("Variable length problem in form input"); }
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $value =~ s/<!--(.|\n)*-->//g;
         unless (($name eq 'body') || ($name eq 'bodyone')) {
            $value =~ s/<([^>]|\n)*>//g;
         }
      $FORM{$name} = $value;
   }
}

sub print_auth {

  &header(Login);
  print qq~

<p>&nbsp;<p><center><div align=center>
<h3><font face="$font">$title: login</font></h3>
<form action="$cgi_url" method="post">
<table border=1 cellspacing=0 cellpadding=4><tr><td align=right>
<font face="$font" size="$size">Username:</font></td><td><input type=text name=username size=10>
</td></tr><tr><td align=right>
<font face="$font" size="$size">Password:</font></td><td><input type=password name=password size=10>
</td></tr><tr><td $tcolor colspan=2><center>
<input type=hidden name=auth value=login>
<input type=submit value="Login">
</td></tr></table>
</form></div></center>
~;

&footer;

}

sub auth {

  if (($fusername eq $username) && ($fpassword eq $password)) { &addform; 
    } else { &error("Not authorized"); }

}

sub lastarchive {
open(FILE,"$basedir/lastarchive.txt");
$lastarch=<FILE>;
close(FILE);
}

sub archive {
open DEX,">$basedir/lastarchive.txt";
print DEX "$ngn";
close(DEX);
}

sub lastupdate {
open(FILE,"$basedir/lastupdate.txt");
$lastupdate=<FILE>;
close(FILE);
}

sub update {
open DEX,">$basedir/lastupdate.txt";
print DEX "$ngn";
close(DEX);
}

sub addform {

  &header("Add new entry");

  print qq~

<center><div align=center>
<h3><font face="$font">$title: add new entry</font></h3>
<form action="$cgi_url" method="post">
<table border=1 cellspacing=0 cellpadding=4><tr><td align=right>
<font face="$font" size="$size">Title:</font></td><td><input type=text name=etitle size=60>
</td></tr><tr><td align=right>
<font face="$font" size="$size">Blurb:</font></td><td>
<TEXTAREA COLS="60" name=bodyone rows=7 wrap=hard></TEXTAREA>
</td></tr><tr><td align=right>
<font face="$font" size="$size">Story:</font></td><td>
<TEXTAREA COLS="60" name=body rows=14 wrap=hard></TEXTAREA>
</td></tr><tr><td $tcolor colspan=2><center>
<input type=hidden name=username value="$fusername">
<input type=submit value="Add This Story"> <input type=reset value="Clear">
</td></tr></table>
</form></div></center>

~;

  &footer;
  exit 0;

}





